const BABYLON = require("babylonjs");
const fs = require("fs")
const XMLHttpRequest = require("xhr2");
const loaders = require("babylonjs-loaders")
//解码

//混淆数组
// const encodeSort = [3, 2, 4, 1];
//还原数组
global.XMLHttpRequest = XMLHttpRequest.XMLHttpRequest;
BABYLON.Tools.GetAbsoluteUrl =
  (url) => {
    return url;
  }
const promise1 = readDracoBuffer("/draco/draco_wasm_wrapper_gltf.js", "wasmUrl");
const promise2 = readDracoBuffer("/draco/draco_decoder_gltf.wasm", "wasmBinaryUrl");
const promise3 = readDracoBuffer("/draco/draco_decoder_gltf.js", "fallbackUrl");
let engine = new BABYLON.NullEngine()
Promise.all([promise1, promise2, promise3]).then(() => {
  let scene = createScene();
  BABYLON.SceneLoader.ImportMesh("", "http://localhost:5656/public/meshes/1/", "123.glb", scene, () => {
    console.log("success! no draco")
  }, null, ()=>{
    console.log("failed! no draco")
  }, ".glb")
  BABYLON.SceneLoader.ImportMesh("", "http://localhost:5656/public/meshes/1/", "123_draco.glb", scene, () => {
    console.log("success! draco ")
  }, null, ()=>{
    console.log("failed! draco ")
  }, ".glb")
})

function readDracoBuffer(url, dracoUrl) {
  url = process.cwd() + url;
  return new Promise((resolve, reject) => {
    fs.readFile(url, (err, data) => {
      if (err) {
        console.log(err)
        reject(dracoUrl + "register failed!")
      }
      BABYLON.DracoCompression.Configuration.decoder[dracoUrl]
        = data;
      console.log(dracoUrl, data);
      resolve(dracoUrl + "register success!");
    })
  })
}
function createScene() {
  let scene = new BABYLON.Scene(engine);
  scene.createDefaultLight();
  // scene.createDefaultSkybox();
  scene.createDefaultCamera(true);
  scene.clearColor = new BABYLON.Color4(0, 0, 0, 0);
  return scene
}








